--*********************************************************************
--*** Code to test Old and New join types                           ***
--*********************************************************************
--*** Separate into four scripts, some code duplicated              ***
--*********************************************************************
-- Alter tablespaces offline/online to flush cache
  alter tablespace adv_oraclass_space offline;
  alter tablespace adv_oraclass_idx_space offline;
  alter tablespace adv_oraclass_space online;
  alter tablespace adv_oraclass_idx_space online;
-- Turn on SQL*Plus tracing tool
  set autotrace on
--*********************************************************************
--*** Test older inner join                                         ***
--*********************************************************************
  select distinct nvl(dname,'No Dept'),count(empno) nbr_emps
     from many_emps emp,many_depts dept
     where emp.deptno = dept.deptno
       and emp.job in ('MANAGER','SALESMAN','ANALYST')
     group by dname;
-- Turn off SQL*Plus tracing tool
  set autotrace off
-- Alter tablespaces offline/online to flush cache
  alter tablespace adv_oraclass_space offline;
  alter tablespace adv_oraclass_idx_space offline;
  alter tablespace adv_oraclass_space online;
  alter tablespace adv_oraclass_idx_space online;
-- Turn on SQL*Plus tracing tool
  set autotrace on
--*********************************************************************
--*** Test newer ANSI inner Join                                    ***
--*********************************************************************
  select distinct nvl(dname,'No Dept'),count(empno) nbr_emps
    from many_emps emp join many_depts dept
      on emp.deptno = dept.deptno
    where emp.job in ('MANAGER','SALESMAN','ANALYST')
    group by dname;
-- Turn off SQL*Plus tracing tool
  set autotrace off
-- Alter tablespaces offline/online to flush cache
  alter tablespace adv_oraclass_space offline;
  alter tablespace adv_oraclass_idx_space offline;
  alter tablespace adv_oraclass_space online;
  alter tablespace adv_oraclass_idx_space online;
-- Turn on SQL*Plus tracing tool
  set autotrace on
--*********************************************************************
--*** Test older, Oracle Outer Join Operator                        ***
--*********************************************************************
  select distinct nvl(dname,'No Dept'),count(empno) nbr_emps
     from many_emps emp,many_depts dept
     where emp.deptno(+) = dept.deptno
     group by dname;
-- Turn off SQL*Plus tracing tool
  set autotrace off
-- Alter tablespaces offline/online to flush cache
  alter tablespace adv_oraclass_space offline;
  alter tablespace adv_oraclass_idx_space offline;
  alter tablespace adv_oraclass_space online;
  alter tablespace adv_oraclass_idx_space online;
-- Turn on SQL*Plus tracing tool
  set autotrace on
--*********************************************************************
--*** Test newer, ANSI Right Join                                   ***
--*********************************************************************
  select distinct nvl(dname,'No Dept'),count(empno) nbr_emps
    from many_emps emp right join many_depts dept
      on emp.deptno = dept.deptno
     group by dname;
-- Turn off SQL*Plus tracing tool
  set autotrace off
-- Turn on SQL*Plus tracing tool
  set autotrace on
--*********************************************************************
--*** Test outer join using union                                   ***
--*********************************************************************
  select nvl(dname,'No Dept') deptname,count(empno) nbr_emps
     from many_emps emp,many_depts dept
     where emp.deptno(+) = dept.deptno
     group by dname
  union
  select nvl(dname,'No Dept') deptname,count(empno) nbr_emps
     from many_emps emp,many_depts dept
     where emp.deptno = dept.deptno(+)
     group by dname;
-- Turn off SQL*Plus tracing tool
  set autotrace off
-- Alter tablespaces offline/online to flush cache
  alter tablespace adv_oraclass_space offline;
  alter tablespace adv_oraclass_idx_space offline;
  alter tablespace adv_oraclass_space online;
  alter tablespace adv_oraclass_idx_space online;
-- Turn on SQL*Plus tracing tool
  set autotrace on
--*********************************************************************
--*** Test newer, ANSI Full Join                                    ***
--*********************************************************************
  select distinct nvl(dname,'No Dept') deptname,count(empno) nbr_emps
    from many_emps emp full join many_depts dept
      on emp.deptno = dept.deptno
     group by dname;
-- Turn off SQL*Plus tracing tool
  set autotrace off
/
