--*********************************************************************
--*** Code to test Old and New join types                           ***
--*********************************************************************
--*** Separate into four scripts, some code duplicated              ***
--*********************************************************************
  alter system flush buffer_cache;
  alter system flush shared_pool;
-- Turn on SQL*Plus tracing tool
  set autotrace on
--*********************************************************************
--*** Test new inner join                                         ***
--*********************************************************************
select substr(prod_name,1,35) prod_name
      ,sum(quantity_sold) units_sold
   from sh.sales join sh.products
      on sh.sales.prod_id = sh.products.prod_id
   where extract(year from time_id) = 2001
   group by prod_name
   order by units_sold;
-- Turn off SQL*Plus tracing tool
  set autotrace off
  alter system flush buffer_cache;
  alter system flush shared_pool;
-- Turn on SQL*Plus tracing tool
  set autotrace on
--*********************************************************************
--*** Test old inner Join                                    ***
--*********************************************************************
select substr(prod_name,1,35) prod_name
      ,sum(quantity_sold) units_sold
   from sh.sales,sh.products
   where sh.sales.prod_id = sh.products.prod_id
     and extract(year from time_id) = 2001
   group by prod_name
   order by units_sold;
-- Turn off SQL*Plus tracing tool
  set autotrace off
  alter system flush buffer_cache;
  alter system flush shared_pool;
-- Turn on SQL*Plus tracing tool
  set autotrace on
--*********************************************************************
--*** Test older, Oracle Outer Join Operator                        ***
--*********************************************************************
select substr(prod_name,1,35) prod_name
      ,sum(quantity_sold) units_sold
   from sh.sales join sh.products
      on sh.sales.prod_id(+) = sh.products.prod_id
   where extract(year from time_id) = 2001
   group by prod_name
   order by units_sold;
-- Turn off SQL*Plus tracing tool
  set autotrace off
  alter system flush buffer_cache;
  alter system flush shared_pool;
-- Turn on SQL*Plus tracing tool
  set autotrace on
--*********************************************************************
--*** Test newer, ANSI Right Join                                   ***
--*********************************************************************
select substr(prod_name,1,35) prod_name
      ,sum(quantity_sold) units_sold
   from sh.sales right join sh.products
      on sh.sales.prod_id = sh.products.prod_id
   where extract(year from time_id) = 2001
   group by prod_name
   order by units_sold;
-- Turn off SQL*Plus tracing tool
  set autotrace off
  alter system flush buffer_cache;
  alter system flush shared_pool;
-- Turn on SQL*Plus tracing tool
  set autotrace on
--*********************************************************************
--*** Test outer join using union                                   ***
--*********************************************************************
select substr(prod_name,1,35) prod_name
      ,sum(quantity_sold) units_sold
   from sh.sales,sh.products
   where sh.sales.prod_id(+) = sh.products.prod_id
     and extract(year from time_id) = 2001
   group by prod_name
  union
select substr(prod_name,1,35) prod_name
      ,sum(quantity_sold) units_sold
   from sh.sales,sh.products
   where sh.sales.prod_id = sh.products.prod_id(+)
     and extract(year from time_id) = 2001
   group by prod_name
   order by units_sold;
-- Turn off SQL*Plus tracing tool
  set autotrace off
  alter system flush buffer_cache;
  alter system flush shared_pool;
-- Turn on SQL*Plus tracing tool
  set autotrace on
--*********************************************************************
--*** Test newer, ANSI Full Join                                    ***
--*********************************************************************
select substr(prod_name,1,35) prod_name
      ,sum(quantity_sold) units_sold
   from sh.sales full join sh.products
      on sh.sales.prod_id = sh.products.prod_id
   where extract(year from time_id) = 2001
   group by prod_name
   order by units_sold;
-- Turn off SQL*Plus tracing tool
  set autotrace off
